<?php
/**
 *
 *   Copyright © 2010-2020 by xhost.ch GmbH
 *
 *   All rights reserved.
 *
 **/

add_hook('EmailTplMergeFields', 1, function ($params) 
{
    return array(
        'multicraft_server_id'=>'Multicraft Server ID',
        'multicraft_panel_url'=>'Multicraft Panel URL',
    );
});

add_hook('EmailPreSend', 1, function ($params) 
{
    $panelUrl = $params['mergefields']['service_server_hostname'];
    if (@require_once(dirname(__FILE__).'/multicraft.php'))
        $panelUrl = MulticraftIntegration::panelUrl($panelUrl, true, 0);
    $serverId = '';
    $r = select_query('mod_multicraft', 'server_id', array('whmcs_service_id'=>intval(@$params['relid'])));
    if ($r)
    {
        $row = mysql_fetch_row($r);
        if (is_array($row) && count($row))
            $serverId = intval($row[0]);
    }
    return array(
        'multicraft_server_id'=>$serverId,
        'multicraft_panel_url'=>$panelUrl,
    );
});

add_hook('AdminAreaHeadOutput', 1, function ($params) 
{
    if (@$params['filename'] == 'clientshostinglist' || @$_GET['rp'] == '/admin/services')
    {
        $out = '';
        $error = '';
        $serverId = intval(@$_POST['multicraft_server_id']);
        if ($serverId)
        {
            $r = select_query('mod_multicraft', 'whmcs_service_id', array('server_id'=>$serverId));
            if ($r)
            {
                $row = mysql_fetch_row($r);
                if (is_array($row) && count($row))
                    $serviceId = (int)$row[0];
                else
                    $serviceId = 0;
            }
            if ($serviceId)
            {
                header('Location: clientsservices.php?id='.$serviceId);
                exit();
            }
            else
                $error = '<div class="errorbox"><b><span class="title">No Result</span></b><br/>No service with Multicraft server ID "'.$serverId.'"</div>';
        }
        else if (strlen(''.@$_POST['multicraft_server_id']))
            $error = '<div class="errorbox"><b><span class="title">No Result</span></b><br/>Invalid Multicraft server ID</div>';

        $form = '
        <tr>
            <td class="fieldlabel">Multicraft Server ID</td>
            <td class="fieldarea"><input type="text" name="multicraft_server_id" class="form-control input-250" value=""></td>
            <td></td>
            <td></td>
        </tr>
        ';

        return '
        <script type="text/javascript">
        /*<![CDATA[*/
        $(function() {
            $("<p>").append('.json_encode($error).').prependTo($("#contentarea>div>ul")[0]);
            $("#tab1>form>table>tbody").append('.json_encode($form).');
        });
        /*]]>*/
        </script>
        ';
    }
    if (@$params['filename'] == 'configservers' && isset($_GET['action']))
    {
        return '
        <script type="text/javascript">
        /*<![CDATA[*/
        $(function() {
            var repl = {
                "HTTPS": "https://",
                "HTTP": "http://",
                "PORT": ":",
                "SLASH": "/",
                "UNDERSCORE": "_",
                "DASH": "-",
                "DOT": "\\\\.",
            };
            var value = $("#inputHostname").val();
            if ($("#inputServerType").val() == "multicraft") {
                for (k in repl) {
                    value = value.replace(new RegExp(k, "g"), k == "DOT" ? "." : repl[k]);
                }
            }
            $("#inputHostname").after("<input type=\"text\" name=\"temp_hostname\" size=\"40\" value=\""
                + value + "\" class=\"form-control input-400\" id=\"temp_inputHostname\">");
            $("#inputHostname").hide();
            $("#temp_inputHostname,#addHostname").on("keyup change", function() { 
                var value = $(this).val();
                if ($(this) != $("#temp_inputHostname"))
                    $("#temp_inputHostname").val(value);
                if ($("#inputServerType").val() == "multicraft") {
                    for (k in repl) {
                        value = value.replace(new RegExp(repl[k], "g"), k);
                    }
                }
                $("#inputHostname").val(value);
            });
        });
        /*]]>*/
        </script>
        ';
    }
    return '';
});

add_hook('AdminAreaPage', 1, function ($params) 
{
	$related = @$params['relatedservices'];
    if (!is_array($related))
        $related = [];
	for ($i = 0; $i < count($related); $i++)
	{
		$r = select_query('mod_multicraft', 'server_id', array('whmcs_service_id'=>intval(@$related[$i]['id'])));
		if ($r)
		{
			$row = mysql_fetch_row($r);
			if (is_array($row) && count($row))
				$related[$i]['multicraft_server_id'] = intval($row[0]);
		}
	}
    return array('relatedservices'=>$related);
});

add_hook('ClientAreaPageProductDetails', 1, function ($params)
{
    if (!@require_once(dirname(__FILE__).'/multicraft.php'))
        return array();
    $params['serverdata']['hostname'] = MulticraftIntegration::panelUrl($params['serverdata']['hostname'], $params['serverdata']['secure'], $params['serverdata']['port']);
    return $params;
});
